// pages/history_record/history_record.js
const wxCharts = require("../../utils/wxcharts-min.js");
const app=getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    subjectIdx:0,
    list:[
      {
        subject:'语文'
      },
      {
        subject: '数学'
      },
      {
        subject: '英语'
      },
    ]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    this.setData(options)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getCanvas('语文')
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  /**
   * 底部导航跳转
   */
  redirectCtl: app.redirectCtl,

  /**
   * 路由跳转
   */
  navigateCtl: app.navigateCtl,
  /**
   * 选择科目
   */
  selectSubject:function(e){
    const { idx, subject}=e.currentTarget.dataset
    this.setData({ subjectIdx: idx, subject })
    this.getCanvas(subject);
  },
  /**
   * 获取维度
   */
  getCanvas:function(res){
    const postData = { fn: this.selectSubject, param: { ...arguments } }
    const { vipId } = this.data;
    var that = this;
    app.post('/api/parents/parents/V2/learningSituationHistory', { vipId, subject: res }, 0, postData).then(res => {
      const { historyList } = res.data;
      this.setData({ historyList })
      for (var i in historyList) {
        that.knowledgeCanvas(i)
      }

    })
  },
  // 知识报告雷达
  knowledgeCanvas: function (idx) {
    var sys = wx.getSystemInfoSync();
    var windowWidth = sys.windowWidth;
    const { historyList } = this.data;
    console.log(historyList[idx])
    new wxCharts({
      animation: true,
      canvasId: 'knowledgeCanvas'+idx,
      type: 'radar',
      categories: historyList[idx].dimensionList,

      series: [{
        name: '个人本月正确数',
        data: historyList[idx].countList,

      },
      {
        name: '所有人平均正确数',
        data: historyList[idx].avgCountList
      }],
      width: windowWidth,
      height: 190,
      dataPointShape: false,
      legend: false,
      extra: {
        radar: {
          max: 100,//雷达数值的最大值
          gridColor: '#D0D5E6',
          labelColor: '#7C819D'
        }
      }
    });
  },
})