// pages/learning_report/learning_report.js
import F2 from '../../utils/f2-canvas/lib/f2';
const wxCharts = require('../../utils/wxcharts-min.js')
const { getGlobalAttributeValue, post, globalData, sharePageDefaultCtl, redirectCtl, navigateCtl } = getApp()
const { baseImgUrl, thumbnail } = globalData
const app = getApp()
/**
 * 判断是否是空对象 
 */
const isEmptyObj = v => {
  if (v !== null && typeof v === 'object') {
    for (const i in v)
      return false
    return true
  }
  return true
}

/**
 * 判断是否是函数 
 */
const isFn = v => {
  return typeof v === 'function'
}

/**
 * 进度条颜色RGB 
 */
const greenRGB = '89, 221, 122'
const yellowRGB = '253, 215, 99'
const redRGB = '255, 100, 101'
const grayRGB = '208, 213, 230'
const purpleRGB = '119, 138, 220'
const blackRGB = '57, 57, 57'
const blueRGB = '84, 179, 236'
              
Page({

  /**
   * 页面的初始数据
   */
  data: {
    baseImgUrl,
    thumbnail,
    greenRGB,
    yellowRGB,
    redRGB,
    grayRGB,
    purpleRGB,
    blackRGB,
    blueRGB,
    opts: {
      lazyLoad: true,
    },
    isServe:false,
    footerData: {
      actIndex: 1,
      list: [
        {
          text: '首页',
          url: '../../image/shou_ye_hui.png',
          actUrl: '../../image/shou_ye.png',
          src: 'homework_list',
          id: 'homework_list'
        },
        {
          text: '学习成长报告',
          url: '../../image/xue_qing_hui.png',
          actUrl: '../../image/xue_qing.png',
          src: 'learning_report',
          id: 'learning_report'
        },
        {
          text: '我的',
          url: '../../image/wo_de_hui.png',
          actUrl: '../../image/wo_de.png',
          src: 'me',
          id: 'me'
        }
      ]
    },
    navIndex: 0,
    navList: [
      {
        text: '周报',
        isLoaded: false,
        subjectIndex: 0,
        subjectList: [
          {
            subject: '语文',
            knowledgePointMasteryDetail: '',
            knowledgePointGoodNumber: 0,
            knowledgePointGeneralNumber: 0,
            knowledgePointPoorNumber: 0,
            // "learningScore": 82,
            // "knowledgePointProportionList": [
            //   {
            //     "knowledgeName": "适得府君书解放路",
            //     "proportion": 0.55
            //   },
            //   {
            //     "knowledgeName": "适得府君解君书解放路",
            //     "proportion": 0.15
            //   },
            //   {
            //     "knowledgeName": "适得府放路",
            //     "proportion": 0.85
            //   },
            //   {
            //     "knowledgeName": "适解放路",
            //     "proportion": 0.95
            //   },
            //   {
            //     "knowledgeName": "适a路",
            //     "proportion": 1
            //   },
            //   {
            //     "knowledgeName": "适b路",
            //     "proportion": 0.75
            //   },
            //   {
            //     "knowledgeName": "适c路",
            //     "proportion": 0.74
            //   },
            // ],
            // "otherKnowledgePointProportionList": [
            //   {
            //     "knowledgeName": "适得府君书解放路",
            //     "proportion": 0.25
            //   },
            //   {
            //     "knowledgeName": "适得府君解君书解放路",
            //     "proportion": 0.25
            //   },
            //   {
            //     "knowledgeName": "适得府放路",
            //     "proportion": 0.25
            //   },
            //   {
            //     "knowledgeName": "适解放路",
            //     "proportion": 0.25
            //   },
            //   {
            //     "knowledgeName": "适路",
            //     "proportion": 0.25
            //   },
            // ],
            // "knowledgePointMasteryList": [
            //   {
            //     "knowledgeName": "sdf",
            //     "mastery": 0.85,
            //     "knowHowDetailList": [
            //       {
            //         "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
            //         "knowledgeVersion": "1"
            //       }
            //     ]
            //   },
            //   {
            //     "knowledgeName": "aafsdf",
            //     "mastery": 0.84,
            //     "knowHowDetailList": [
            //       {
            //         "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
            //         "knowledgeVersion": "1"
            //       }
            //     ]
            //   },
            //   {
            //     "knowledgeName": "fffffffffffff",
            //     "mastery": 0.75,
            //     "knowHowDetailList": [
            //       {
            //         "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
            //         "knowledgeVersion": "1"
            //       }
            //     ]
            //   },
            //   {
            //     "knowledgeName": "fffffffffffff",
            //     "mastery": 0.25,
            //     "knowHowDetailList": [
            //       {
            //         "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
            //         "knowledgeVersion": "1"
            //       }
            //     ]
            //   },
            // ]
          },
          {
            subject: '数学',
            knowledgePointMasteryDetail: '',
            knowledgePointGoodNumber: 0,
            knowledgePointGeneralNumber: 0,
            knowledgePointPoorNumber: 0,
            // "learningScore": 82,
            // "knowledgePointProportionList": [
            //   {
            //     "knowledgeName": "",
            //     "proportion": 0.25
            //   }
            // ],
            // "otherKnowledgePointProportionList": [
            //   {
            //     "knowledgeName": "",
            //     "proportion": 0.25
            //   }
            // ],
            // "knowledgePointMasteryList": [
            //   {
            //     "knowledgeName": "",
            //     "mastery": 0.25,
            //     "knowHowDetailList": [
            //       {
            //         "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
            //         "knowledgeVersion": "1"
            //       }
            //     ]
            //   }
            // ]
          },
          {
            subject: '英语',
            knowledgePointMasteryDetail: '',
            knowledgePointGoodNumber: 0,
            knowledgePointGeneralNumber: 0,
            knowledgePointPoorNumber: 0,
            // "learningScore": 82,
            // "knowledgePointProportionList": [
            //   {
            //     "knowledgeName": "",
            //     "proportion": 0.25
            //   }
            // ],
            // "otherKnowledgePointProportionList": [
            //   {
            //     "knowledgeName": "",
            //     "proportion": 0.25
            //   }
            // ],
            // "knowledgePointMasteryList": [
            //   {
            //     "knowledgeName": "",
            //     "mastery": 0.25,
            //     "knowHowDetailList": [
            //       {
            //         "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
            //         "knowledgeVersion": "1"
            //       }
            //     ]
            //   }
            // ]
          },
        ],
        nodataObj: {
          text: '暂无数据',
          padding: '250rpx 0',
          image: '../../image/wu_shu_ju.png'
        },
      },
      {
        text: '月报',
        isLoaded: false,
        subjectIndex: 0,
        // "learningScore": 82,
        // "lastMonth": "9",
        // "increasedScore": 11,
        // "transcendedStudentProportion": 0.4,
        // "averageUsedTime": 82,
        subjectList: [
          // {
          //   "subject": "语文",
          //   "learnedUnitList": [
          //     {
          //       "unitName": "《古诗两首》"
          //     }
          //   ],
          //   "weakKnowledgePointMasteryList": [
          //     {
          //       "knowledgeName": "sdf",
          //       "mastery": 0.85,
          //       "knowHowDetailList": [
          //         {
          //           "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
          //           "knowledgeVersion": "1"
          //         }
          //       ]
          //     },
          //     {
          //       "knowledgeName": "aafsdf",
          //       "mastery": 0.84,
          //       "knowHowDetailList": [
          //         {
          //           "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
          //           "knowledgeVersion": "1"
          //         }
          //       ]
          //     },
          //     {
          //       "knowledgeName": "fffffffffffff",
          //       "mastery": 0.75,
          //       "knowHowDetailList": [
          //         {
          //           "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
          //           "knowledgeVersion": "1"
          //         }
          //       ]
          //     },
          //     {
          //       "knowledgeName": "fffffffffffff",
          //       "mastery": 0.25,
          //       "knowHowDetailList": [
          //         {
          //           "knowHowDetailId": "d4bf0c0f-2c19-4881-a18f-3b15ea0a7290",
          //           "knowledgeVersion": "1"
          //         }
          //       ]
          //     },
          //   ]
          // },
          // {
          //   "subject": "数学",
          //   "learnedUnitList": [
          //     {
          //       "unitName": "《古诗两首》"
          //     }
          //   ],
          //   "weakKnowledgePointMasteryList": [
          //     {
          //       "knowledgeName": "",
          //       "mastery": 0.25
          //     }
          //   ]
          // },
          // {
          //   "subject": "英语",
          //   "learnedUnitList": [
          //     {
          //       "unitName": "《古诗两首》"
          //     }
          //   ],
          //   "weakKnowledgePointMasteryList": [
          //     {
          //       "knowledgeName": "",
          //       "mastery": 0.25
          //     }
          //   ]
          // },
        ],
        // "subjectKnowledgeInfoList": [
        //   {
        //     "subject": "语文",
        //     "learnedUnitList": [
        //       {
        //         "unitName": "《古诗两首》"
        //       }
        //     ],
        //     "weakKnowledgePointMasteryList": [
        //       {
        //         "knowledgeName": "",
        //         "mastery": 0.25
        //       }
        //     ]
        //   }
        // ],
        nodataObj: {
          text: '暂无数据',
          padding: '250rpx 0',
          image: '../../image/wu_shu_ju.png'
        },
      },
      {
        text: '学期',
        isLoaded: false,
        accuracyArray: [
          {
            name: '所有人平均正确率',
            color: 'rgba(124, 129, 157, 1)',
          },
          {
            name: '个人正确率',
            color: 'rgba(255, 100, 101, 1)',
          },
        ],
        subjectIndex: 0,
        // "vipId": "1475682f-739b-48af-8e10-b91d5537a38e",
        // "studentName": "陈小二",
        // "studentImg": "/2017/04/12/348b4d74-e105-42d7-b9ca-dbfac10b1cf8.jpg",
        // "labels": ["古灵精怪", "注意力集中", "团结友爱", "上课认真"],
        // "overallSituation": [
        //   "语文存在严重的拼写错误，对此我们建议多对孩子的语文作业督促",
        //   "数学存在严重的拼写错误，对此我们建议多对孩子的数学作业督促"
        // ],
        // "subjectList": ["语文", "数学", "英语"],
        subjectList: [
          // {
          //   subject: '语文',
          //   isShowLeaningSuggest: false,
          //   "knowledge": {
          //     "dimension": [
          //       "维度1",
          //       "维度2",
          //       "维度3",
          //       "维度4",
          //       "维度5",
          //       "维度1",
          //       "维度2",
          //       "维度3",
          //       "维度4",
          //       "维度5"
          //     ],
          //     "thisMonthTrueCount": [
          //       10,
          //       100,
          //       60,
          //       70,
          //       100,
          //       10,
          //       100,
          //       60,
          //       70,
          //       100,
          //     ],
          //     "overallAvgTrueCount": [
          //       40,
          //       20,
          //       60,
          //       70,
          //       200,
          //       40,
          //       20,
          //       60,
          //       70,
          //       200
          //     ],
          //     "diagnostic": "教师使用教堂用语是为了提高学生的口语",
          //     "leaningSuggest": [
          //       {
          //         "title": "线性代数题目如何蒙中？",
          //         "content": "三长一短选最短"
          //       },
          //       {
          //         "title": "线性代数题目如何蒙中？",
          //         "content": "三短一长选最长"
          //       },
          //       {
          //         "title": "线性代数题目如何蒙中？",
          //         "content": "不确定选b"
          //       }
          //     ]
          //   },
          //   "knowledgePoint": [
          //     {
          //       "noKnowledgePoint": [
          //         {
          //           "celebrities": [
          //             "骄傲、谦虚、懦弱、灰尘、捧场、时代、价钱"
          //           ],
          //           "name": "认识11个生字，会写13个字"
          //         },
          //         {
          //           "celebrities": [
          //             "守护、植株、等待、宋朝、耕耘、触电、颈项、解释、其中、希冀"
          //           ],
          //           "name": "认识11个生字，会写14个生字"
          //         }
          //       ],
          //       "percent": 91,
          //       "style": "字词",
          //       "totalNum": 8,
          //       "wrongNum": 8
          //     },
          //     {
          //       "noKnowledgePoint": [
          //         {
          //           "celebrities": [
          //             "骄傲、谦虚、懦弱、灰尘、捧场、时代、价钱"
          //           ],
          //           "name": "认识11个生字，会写13个字"
          //         },
          //         {
          //           "celebrities": [
          //             "守护、植株、等待、宋朝、耕耘、触电、颈项、解释、其中、希冀"
          //           ],
          //           "name": "认识11个生字，会写14个生字"
          //         }
          //       ],
          //       "percent": 63,
          //       "style": "词",
          //       "totalNum": 8,
          //       "wrongNum": 8
          //     }
          //   ],
          //   "homeworkAccuracyRateList": [
          //     {
          //       "date": "04.02",
          //       "rate": 35,
          //       color: `rgba(${redRGB},1)`
          //     },
          //     {
          //       "date": "04.02",
          //       "rate": 65,
          //       color: `rgba(${yellowRGB},1)`
          //     },
          //     {
          //       "date": "04.02",
          //       "rate": 90,
          //       color: `rgba(${greenRGB},1)`
          //     },
          //     {
          //       "date": "04.02",
          //       "rate": 100,
          //       color: `rgba(${greenRGB},1)`
          //     },
          //     {
          //       "date": "04.02",
          //       "rate": 80,
          //       color: `rgba(${yellowRGB},1)`
          //     },
          //     {
          //       "date": "04.02",
          //       "rate": 0,
          //       color: `rgba(${redRGB},1)`
          //     },
          //     {
          //       "date": "04.02",
          //       "rate": 59,
          //       color: `rgba(${redRGB},1)`
          //     },
          //   ]
          // },
          // {
          //   subject: '数学',

          // },
          // {
          //   subject: '英语',

          // },
        ],
        nodataObj: {
          text: '暂无数据',
          padding: '250rpx 0',
          image: '../../image/wu_shu_ju.png'
        },
      },
    ]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const { status = 0, vipId = '' } = options
    options.status = status
    options.vipId = vipId || getGlobalAttributeValue(`parentVipId-${getGlobalAttributeValue('userId')}`)
    options.userId = app.globalData.userId || wx.getStorageSync('userId')
    // 周报，月报
    // options.vipId = vipId || 'e150dfb8-da9d-45bb-9587-9cac09dad6c7'
    // 学期报
    // options.vipId = vipId || '6d246891-b885-4c56-921c-7f98c4ba0c49'
    // 张正坤的vipid
    // options.vipId = '297ec62e-1d6b-41ae-b980-7fe5ef3d702d'
    // options.vipId = '297ec62e-1d6b-41ae-b980-7fe5ef3d702d'
    const temp = {}
    temp['options'] = options
    temp['navIndex'] = status ? status - 1 : 0
    this.setData(temp)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    const {vipId}=this.data.options
    if(vipId){
      this.getData()
    }
    this.getChildInfo()
    this.chatHomeworkTime()
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.getData(() => {
      wx.stopPullDownRefresh()
    })
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePageDefaultCtl)) sharePageDefaultCtl()
  },

  /**
   * 底部导航跳转
   */
  redirectCtl,

  /**
   * 路由跳转
   */
  navigateCtl,

  /**
   * 获取数据
   */
  getData: function (cb) {
    const { navIndex = 0 } = this.data
    switch (navIndex) {
      case 0:
        this.getWeekReport(cb)
        break
      case 1:
        this.getMonthReport(cb)
        break
      case 2:
        this.getDataOfSituation(cb)
        break
    }
  },
  // 获取孩子信息
  getChildInfo: function () {
    const { options={} } = this.data;
    const { vipId = '', userId='' } = options
    const postData = { fn: this.getChildInfo, param: { ...arguments } }
    post('/api/parents/parents/V2/getMyInfo', {}, 0, postData).then(res => {
      const { childList,phone} = res.data;
      if (!phone) {
        this.redirectCtl({ url: 'phone', method: { isFrist: 1} }, true)
      } 
      for (var i in childList){
        if (childList[i].vipId==vipId){
          wx.setStorageSync(`parentVipLiIdx-${userId}`, i)
        }
      }
    })
  },

  /**
   * 获取周报数据
   */
  getWeekReport: function (cb) {
    const postData = { fn: this.getWeekReport, param: { ...arguments } }
    const { navList = [], navIndex = 0, options = {} } = this.data
    const { vipId = '' } = options
    const { subjectIndex = 0, subjectList = [] } = navList[navIndex] || {}
    const { subject = '' } = subjectList[subjectIndex] || {}

    // 当已存在数据的情况下，不用请求接口数据
    const { learningScore = 0, knowledgePointProportionList = [], otherKnowledgePointProportionList = [], moduleList = [] } = subjectList[subjectIndex] || {}
    if (learningScore && knowledgePointProportionList.length && otherKnowledgePointProportionList.length && moduleList.length) {
      this.drawRingCanvasOfKnowledgePoint()
      if (isFn(cb)) cb()
      return
    }

    post('/api/parents/parents/V2/learningGrowthReportV2', { vipId, subject }, 0, postData).then(res => {
      const { 
        learningScore = 0, 
        totalKnowledgeNum = 0,
        masterWellKnowledgeNum = 0,
        masterInfirmlyKnowledgeNum = 0,
        notMasteredKnowledgeNum = 0,
        knowledgePointProportionList = [], 
        otherKnowledgePointProportionList = [], 
        moduleList = [] 
      } = res.data || {}

      // 设置默认知识点掌握情况及对应的数量
      // const {
      //   knowledgePointGoodNumber = 0,
      //   knowledgePointGeneralNumber = 0,
      //   knowledgePointPoorNumber = 0
      // } = (list => {
      //   let knowledgePointGoodNumber = 0
      //   let knowledgePointGeneralNumber = 0
      //   let knowledgePointPoorNumber = 0
      //   for (const v of list) {
      //     const { mastery = 0 } = v
      //     const num = ~~(mastery * 100)
      //     if (num >= 85) {
      //       knowledgePointGoodNumber++
      //     } else if (num < 85 && num >= 60) {
      //       knowledgePointGeneralNumber++
      //     } else {
      //       knowledgePointPoorNumber++
      //     }
      //   }
      //   return {
      //     knowledgePointGoodNumber,
      //     knowledgePointGeneralNumber,
      //     knowledgePointPoorNumber
      //   }
      // })(knowledgePointMasteryList)

      // 知识点掌握情况
      const knowledgePointMasteryDetail = learningScore >= 95 ? '优秀' : learningScore >= 85 ? '良好' : learningScore >= 75 ? '一般' : '欠佳'

      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].learningScore`] = learningScore
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePointProportionList`] = knowledgePointProportionList
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].otherKnowledgePointProportionList`] = otherKnowledgePointProportionList
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].moduleList`] = moduleList
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePointMasteryDetail`] = knowledgePointMasteryDetail
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].totalKnowledgeNum`] = totalKnowledgeNum
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePointGoodNumber`] = masterWellKnowledgeNum
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePointGeneralNumber`] = masterInfirmlyKnowledgeNum
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePointPoorNumber`] = notMasteredKnowledgeNum
      this.setData(temp)
      this.drawRingCanvasOfKnowledgePoint()
      if (isFn(cb)) cb()
    }).catch (() => {
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      this.setData(temp)
      if (isFn(cb)) cb()
    })
  },

  /**
   * 获取月报数据
   */
  getMonthReport: function (cb) {
    const postData = { fn: this.getMonthReport, param: { ...arguments } }
    const { navList = [], navIndex = 0, options = {} } = this.data
    const { vipId = '' } = options

    // 当已存在数据的情况下，不用请求接口数据
    const { subjectList = [] } = navList[navIndex] || {}
    if (subjectList.length) {
      if (isFn(cb)) cb()
      return
    }

    post('/api/parents/parents/V2/learningGrowthReportForMonthV2', { vipId }, 0, postData).then(res => {
      const { 
        learningScore = 0, 
        lastMonth = '', 
        increasedScore = 0, 
        transcendedStudentProportion = 0,
        averageUsedTime = 0, 
        subjectKnowledgeInfoList = []
      } = res.data || {}
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      temp[`navList[${navIndex}].learningScore`] = learningScore
      temp[`navList[${navIndex}].lastMonth`] = lastMonth
      temp[`navList[${navIndex}].increasedScore`] = increasedScore
      temp[`navList[${navIndex}].transcendedStudentProportion`] = transcendedStudentProportion
      temp[`navList[${navIndex}].averageUsedTime`] = averageUsedTime
      temp[`navList[${navIndex}].subjectList`] = subjectKnowledgeInfoList
      this.setData(temp)
      if (isFn(cb)) cb()
    }).catch(() => {
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      this.setData(temp)
      if (isFn(cb)) cb()
    })
  },

  /**
   * 获取学情初始数据
   */
  getDataOfSituation: function (cb) {
    const postData = { fn: this.getDataOfSituation, param: { ...arguments } }
    const { navList = [], navIndex = 0, options = {} } = this.data
    const { vipId = '' } = options

    // 当已存在数据的情况下，不用请求接口数据
    const { subjectList = [], studentName = '', studentImg = '', labels = [], overallSituation = [] } = navList[navIndex] || {}
    if (subjectList.length && studentName && studentImg && labels.length && overallSituation.length) {
      this.getSubjectOfSituation(cb)
      return
    }

    post('/api/parents/parents/learningSituationAbstract', { vipId }, 0, postData).then(res => {
      const { studentName = '', studentImg = '', labels = [], overallSituation = [], subjects = [] } = res.data || {}
      const temp = {}
      temp[`navList[${navIndex}].studentName`] = studentName
      temp[`navList[${navIndex}].studentImg`] = studentImg
      temp[`navList[${navIndex}].labels`] = labels
      temp[`navList[${navIndex}].overallSituation`] = overallSituation
      temp[`navList[${navIndex}].subjects`] = subjects
      temp[`navList[${navIndex}].subjectList`] = (res => {
        const arr = []
        for (const v of res) {
          arr.push({ subject: v })
        }
        return arr
      })(subjects)
      this.setData(temp)
      if (subjects.length > 0) {
        this.getSubjectOfSituation(cb)
      } else {
        const temp = {}
        temp[`navList[${navIndex}].isLoaded`] = true
        this.setData(temp)
        if (isFn(cb)) cb()
      }
    }).catch(() => {
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      this.setData(temp)
      if (isFn(cb)) cb()
    })
  },

  /**
   * 获取单科学情详情
   */
  getSubjectOfSituation: function (cb) {
    const postData = { fn: this.getSubjectOfSituation, param: { ...arguments } }
    const { navList = [], navIndex = 0, options = {} } = this.data
    const { vipId = '' } = options
    const { subjectIndex = 0, subjectList = [] } = navList[navIndex] || {}
    const { subject = '', semester = 0, grade = '' } = subjectList[subjectIndex] || {}

    // 当已存在数据的情况下，不用请求接口数据
    const { knowledge = {}, knowledgePoint = [], homeworkAccuracyRateList = [] } = subjectList[subjectIndex] || {}
    if (!isEmptyObj(knowledge) && knowledgePoint.length && homeworkAccuracyRateList.length) {
      this.drawRadarCanvasOfKnowledge()
      this.drawRingCanvasOfKnowledgePointMastery()
      if (isFn(cb)) cb()
      return
    }

    post('/api/parents/parents/V2/learningSituationDetailNew', { vipId, subject, semester, grade }, 0, postData).then(res => {
      const { knowledge = '', knowledgePoint = '', homeworkAccuracyRateList = [] } = res.data
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledge`] = knowledge
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePoint`] = knowledgePoint
      temp[`navList[${navIndex}].subjectList[${subjectIndex}].homeworkAccuracyRateList`] = homeworkAccuracyRateList
      this.setData(temp)
      this.drawRadarCanvasOfKnowledge()
      this.drawRingCanvasOfKnowledgePointMastery()
      if (isFn(cb)) cb()
    }).catch(() => {
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      this.setData(temp)
      if (isFn(cb)) cb()
    })
  },

  /**
   * 选择切换项
   */
  selectNavIndexCtl: function (e) {
    const { index } = e.currentTarget.dataset
    const { navIndex = 0, navList = [] } = this.data || {}
    const { subjectList = [] } = navList[index] || {}
    if (navIndex == index) return
    const temp = {}
    temp[`navIndex`] = index
    this.setData(temp)
    this.getData()
  },

  /**
   * 选择切换学情科目项
   */
  selectSubjectIndexCtl: function (e) {
    const { index } = e.currentTarget.dataset
    console.log(index)
    const { navList = [], navIndex = 0 } = this.data
    const { subjectList = [], subjectIndex = 0 } = navList[navIndex] || {}
    if (subjectIndex == index) return
    const temp = {}
    temp[`navList[${navIndex}].subjectIndex`] = index
    this.setData(temp)
    this.getData()
  },

  /**
   * 获取容器高度，使页面滚动到容器底部
   */ 
  pageScrollToBottom: function () {
    wx.createSelectorQuery().select('#wrapper').boundingClientRect(function (rect) {
      wx.pageScrollTo({
        scrollTop: rect.bottom
      })
    }).exec()
  },

  /**
   * 切换显示未掌握知识点
   */
  toggleShowNoknowledgePointCtl: function (e) {
    const { index  = 0 } = e.currentTarget.dataset
    const { navList = [], navIndex = 0 } = this.data
    const { subjectList = [], subjectIndex = 0 } = navList[navIndex] || {}
    const { knowledgePoint = [] } = subjectList[subjectIndex] || {}
    const { isShowNoknowledgePoint = false } = knowledgePoint[index] || {}
    const temp = {}
    temp[`navList[${navIndex}].subjectList[${subjectIndex}].knowledgePoint[${index}].isShowNoknowledgePoint`] = !isShowNoknowledgePoint
    this.setData(temp)
  },

  /**
   * 切换显示学习建议
   */
  toggleLeaningSuggestCtl: function () {
    const { navList = [], navIndex = 0 } = this.data
    const { subjectList = [], subjectIndex = 0 } = navList[navIndex] || {}
    const { isShowLeaningSuggest = false } = subjectList[subjectIndex] || {}
    const temp = {}
    temp[`navList[${navIndex}].subjectList[${subjectIndex}].isShowLeaningSuggest`] = !isShowLeaningSuggest
    this.setData(temp)
  },

  /**
   * 绘制知识点圆环
   */
  drawRingCanvasOfKnowledgePoint: function () {
    const { navList = [], navIndex = 0 } = this.data
    const { subjectList = [], subjectIndex = 0 } = navList[navIndex] || {}
    const { knowledgePointProportionList = [] } = subjectList[subjectIndex] || {}
    if (knowledgePointProportionList.length === 0) return
    this.selectComponent('#knowledgePointRingCanvas').init(function (canvas, width, height) {
      // 数据
      const data = (list => {
        const arr = []
        for (const v of list) {
          const { knowledgeName = '', proportion = 0 } = v
          arr.push({
            const: 'const',
            type: knowledgeName,
            percent: ~~(+proportion * 100)
          })
        }
        return arr
      })(knowledgePointProportionList)

      // 生成画布
      const chart = new F2.Chart({
        el: canvas,
        width,
        height
      })
      chart.source(data)
      chart.coord('polar', {
        transposed: true,
        radius: 0.9,
        innerRadius: 0.5
      })
      chart.axis(false)
      chart.legend(false)
      chart.tooltip(true)
      chart.interval().position('const*percent').adjust('stack').color('type', [
        `rgba(${greenRGB}, 1)`, 
        `rgba(${yellowRGB}, 1)`, 
        `rgba(${redRGB}, 1)`, 
        `rgba(${purpleRGB}, 1)`])
      chart.pieLabel({
        sidePadding: 30,
        activeShape: true,
        label1: function label1(data) {
          return {
            text: data.percent + '%',
            fill: `rgba(${blueRGB}, 1)`,
            fontWeight: 'bold'
          };
        },
        label2: function label2(data) {
          return {
            text: data.type.length > 3 ? data.type.substring(0, 3) + '...' : data.type,
            fill: `rgba(${blackRGB}, 1)`,
            fontWeight: 'bold'
          };
        },
        onClick: function onClick(e) {
          const { data = {} } = e
          console.log(data)
        }
      });
      chart.render()
      return chart
    })
  },

  /**
   * 绘制雷达图
   */
  drawRadarCanvasOfKnowledge: function () {
    const { navList = [], navIndex = 0 } = this.data
    const { subjectList = [], subjectIndex = 0, accuracyArray = [] } = navList[navIndex] || {}
    const { knowledge = {} } = subjectList[subjectIndex] || {}
    if (isEmptyObj(knowledge)) return
    const Fn = (obj, canvasId, arr) => {
      if (!canvasId) return
      const { dimension = [], thisMonthTrueCount = [], overallAvgTrueCount = [] } = obj
      new wxCharts({
        animation: true,
        canvasId,
        type: 'radar',
        categories: dimension,
        series: ((arr, data) => {
          for (let i in arr) {
            arr[i].data = data[i]
          }
          return arr
        })(arr, [overallAvgTrueCount, thisMonthTrueCount]),
        width: 300,
        height: 300,
        dataPointShape: false,
        legend: false,
        extra: {
          radar: {
            max: 100,//雷达数值的最大值
            gridColor: '#D0D5E6',
            labelColor: '#7C819D'
          }
        }
      })
    }
    Fn(knowledge, 'knowledgeRadarCanvas', accuracyArray)
  },

  /**
   * 绘制圆环进度条
   */
  drawRingCanvasOfKnowledgePointMastery: function () {
    const { navList = [], navIndex = 0 } = this.data
    const { subjectList = [], subjectIndex = 0, accuracyArray = [] } = navList[navIndex] || {}
    const { knowledgePoint = {} } = subjectList[subjectIndex] || {}
    if (isEmptyObj(knowledgePoint)) return
    const Fn = (canvasId = '', percent = 0) => {
      if (!canvasId) return
      
      // 计算圆环颜色
      const color = percent < 15||percent==15 ? greenRGB : percent < 40||percent==40 ? yellowRGB : redRGB

      // 配置项参数
      const startColor = `rgba(${color}, 1)`
      const endColor = `rgba(${color}, 1)`
      const baseColor = `rgba(${grayRGB}, 1)`

      const width = 29
      const height = 29
      const minWidth = 25
      const baseLineWidth = 6
      const actLineWidth = 8
      const actLineCap = 'round'
      const fontSize = 12
      const textAlign = 'center'
      const baseLine = 'middle'
      const fontColor = `rgba(${blackRGB}, 1)`

      // 初始化画布 
      const ctx = wx.createCanvasContext(canvasId)
      const grd = ctx.createLinearGradient(width / 2, 0, width / 2, height)
      grd.addColorStop(0, endColor)
      grd.addColorStop(1, startColor)

      // 圆环边框
      ctx.beginPath()
      ctx.arc(width, height, minWidth, 0, 2 * Math.PI)
      ctx.setStrokeStyle(baseColor)
      ctx.setLineWidth(baseLineWidth)
      ctx.stroke()

      // 圆环
      if (percent > 0) {
        ctx.beginPath()
        ctx.arc(width, height, minWidth, -Math.PI / 2, Math.PI * 2 * percent / 100 - Math.PI / 2, false)
        ctx.setStrokeStyle(grd)
        ctx.setLineWidth(actLineWidth)
        ctx.setLineCap(actLineCap)
        ctx.stroke()
      }

      // 占比值
      ctx.setFontSize(fontSize)
      ctx.setTextAlign(textAlign)
      ctx.setTextBaseline(baseLine)
      ctx.setFillStyle(fontColor)
      ctx.fillText(`${percent}%`, width, height)

      ctx.draw()
    }
    for (let i in knowledgePoint) {
      Fn(`knowledgePointMasteryRingCanvas-${i}`, ~~knowledgePoint[i].percent)
    }
  },
  /**
   * 查询作业吧服务时间
   */
  chatHomeworkTime: function () {
    const postData = { fn: this.chatHomeworkTime, param: { ...arguments } }
    const {options = {},navList = [], navIndex = 0 } = this.data
    const { vipId = '' } = options
    app.post('/api/parents/parents/V2/service/findZybServiceList', { vipId}, 0, postData).then(res => {
      const { list } = res.data;
      if (list.length == 0) {
        this.setData({ isServe:true})
      } else if (list.length == 1) {
        for(var i in list){
          if(list[i].type==5){
            this.setData({ isServe: true});
          }
        }
      }
      const temp = {}
      temp[`navList[${navIndex}].isLoaded`] = true
      this.setData(temp)
    })
  },
})